<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.vcaccount_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>

      <template slot="menu" slot-scope="scope">
        <el-button size="mini" type="text" icon="el-icon-setting">
          <el-dropdown>
            <span class="el-dropdown-link">
              更多<i class="el-icon-arrow-down el-icon--right"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item v-if="permission.vcaccount_login" type="text" @click.native="vcLogin(scope.row.accountName, scope.row.pwd, scope.row.appKey)">登录</el-dropdown-item>
              <el-dropdown-item v-if="permission.vcaccount_sync" type="text" @click.native="syncDevices(scope.row.accountName)">同步设备</el-dropdown-item>
              <el-dropdown-item v-if="permission.vcaccount_delete" type="text" @click.native="rowDel(scope.row)">删除</el-dropdown-item>
            </el-dropdown-menu>

          </el-dropdown>
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, vcLogin, syncByAccount} from "../../../../api/device/videocloudaccount.js";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          delBtn: false,
          dialogClickModal: false,
          column: [
            {
              label: "账号",
              prop: "accountName",
              width: 140,
              search: true,
              rules: [{
                required: true,
                message: "请输入用户名称",
                trigger: "blur"
              }]
            },
            {
              label: "密码",
              prop: "pwd",
              width: 140,
              rules: [{
                required: true,
                message: "请输入密码",
                trigger: "blur"
              }],
              hide: true,
              viewDisplay: false,
            },
            {
              label: "appKey",
              prop: "appKey",
              width: 140,
              rules: [{
                required: true,
                message: "请输入appKey",
                trigger: "blur"
              }],
              hide: true,
              viewDisplay: false,
            },
            {
              label: "城市名称",
              prop: "cityName",
              rules: [{
                required: false,
                message: "请输入城市名称",
                trigger: "blur"
              }]
            },
            {
              label: "行政区域名称",
              prop: "countryName",
              labelWidth: 100,
              rules: [{
                required: false,
                message: "请输入行政区域名称",
                trigger: "blur"
              }]
            },
            {
              label: "邮箱",
              prop: "email",
              width: 150,
              rules: [{
                required: false,
                message: "请输入邮箱",
                trigger: "blur"
              }]
            },
            {
              label: "最近登录时间",
              prop: "lastLoginTimeString",
              width: 150,
              editDisplay: false,
              addDisplay: false,
              rules: [{
                required: false,
                message: "请输入最近登录时间",
                trigger: "blur"
              }]
            },
            {
              label: "手机号码",
              prop: "mobile",
              rules: [{
                required: false,
                message: "请输入手机号码",
                trigger: "blur"
              }]
            },
            {
              label: "组织名称",
              prop: "orgName",
              rules: [{
                required: false,
                message: "请输入组织名称",
                trigger: "blur"
              }]
            },
            {
              label: "省名称",
              prop: "provinceName",
              rules: [{
                required: false,
                message: "请输入省名称",
                trigger: "blur"
              }]
            },
            {
              label: "真实名称",
              prop: "realName",
              rules: [{
                required: false,
                message: "请输入真实名称",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.vcaccount_add, false),
          viewBtn: this.vaildData(this.permission.vcaccount_view, false),
          delBtn: this.vaildData(this.permission.vcaccount_delete, false),
          editBtn: this.vaildData(this.permission.vcaccount_edit, false),
          loginBtn: this.vaildData(this.permission.vcaccount_login, false),
          syncBtn: this.vaildData(this.permission.vcaccount_sync, false),
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      vcLogin(accountName, pwd, appKey){
        let body = {"accountName": accountName, "pwd": pwd, "appKey": appKey}
        vcLogin(body).then(res => {
          if (res.data.success) {
            this.$message({
              type: "success",
              message: "登录成功"
            });
          } else {
            this.$message({
              type: "error",
              message: res.data.msg
            });
          }
        })
      },
      syncDevices(accountName){
        let params = {"accountName": accountName}
        syncByAccount(params).then(res => {
          if (res.data.success) {
            this.$message({
              type: "success",
              message: res.data.msg
            });
          } else {
            this.$message({
              type: "error",
              message: res.data.msg
            });
          }
        })
      },
      delete(id){
        remove(id)
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
